<template>
  <Row class="manager-stock-data-news">
    <stock-list-page :search-columns="searchColumns"
                     :table-columns="tableColumns"
                     :table-data="tableData"
                     :total-data-amount="totalData"
                     :page-size-options="[30]"
                     :default-page-at="pageAt"
                     @search="getDailyNewsAction" @selected="updateSelectedNewsAction">
      <Row>
        <!-- search date-time -->
        <div class="inline-block tool-item gray-background">
          <DatePicker type="date" placeholder="Select date"
                      fomat="yyyy/MM/dd"
                      v-model="date"
                      style="width: 120px"
                      @on-change="resetCrawlingDataAction">
          </DatePicker>
          <div class="search-btn div-btn" @click="getDailyNewsAction">
            <Icon type="md-send"></Icon>
          </div>
        </div>

        <!-- crawling -->
        <template v-if="date">
          <div class="inline-block tool-item gray-background">
            <div class="page-message inline-block">
              <div class="inline-block">crawled at: </div>
              <div class="inline-block">
                <i-input v-model="crawlingPage" :style="{width: '40px'}"></i-input>
              </div>
            </div>
            <div class="crawled-btn div-btn" @click="crawledDailyNewsAction">
              <Icon type="md-bug"></Icon>
            </div>
            <div class="crawling-message">{{crawlingResultMessage}}</div>
          </div>
        </template>

        <!-- classify by date-time -->
        <div class="inline-block tool-item gray-background">
          <DatePicker type="daterange"
                      v-model="classifyDates"
                      placeholder="classify range"
                      style="width: 180px">
          </DatePicker>
          <div class="classify-by-time-btn div-btn" @click="classifyByTimeAction">
            <Icon type="md-git-network"></Icon>
          </div>
        </div>

        <template v-if="selectedData.length > 0 && date">
          <div class="literal-div-btn classify-btn" @click="classifyAction">Classify Selected</div>
        </template>
      </Row>
    </stock-list-page>
  </Row>
</template>

<script>
import StockListPage from "../../../components/StockListPage";
import { columns } from '../../../helpers/list';
import { validators as api } from '../../../configs/request-validator/company-news';

const actions = {
  resetCrawlingDataAction() {
    this.crawlingPage = 1;
    this.crawlingResultMessage = undefined;
  },
  async getDailyNewsAction(filter) {
    const hasDate = !!this.date;
    if (hasDate) {
      const filterFromStockListPageEmit = !(filter instanceof MouseEvent);
      if (filterFromStockListPageEmit) {
        this.currentSearchFilter = filter;
      }

      const date = (this.date).toLocaleDateString();
      this.currentSearchFilter.pageAt = (date !== this.lastDate) ? 1 : this.currentSearchFilter.pageAt;
      const requestData = {
        pageAt: this.currentSearchFilter.pageAt,
        pageSize: this.currentSearchFilter.pageSize || 30,
        timestamp: (new Date(`${date} 00:00:00`)).getTime(),
      };
      this.$conditionMutator(requestData, this.currentSearchFilter);
      this.pageAt = this.currentSearchFilter.pageAt;
      this.lastDate = date;

      try {
        const { data } = await this.$api(api.AccessDailyNewsRequest, requestData);
        const hasData = data['news'].length > 0;
        const isSearchOnSpecialColumn = requestData['conditions'].length > 0;
        if (hasData || isSearchOnSpecialColumn) {
          this.tableData = data['news'];
          this.totalData = data['total'];
        } else {
          this.tableData = [];
          this.totalData = 0;
          this.$Notice.error({
            title: 'News Error',
            desc: `No news at ${date}`,
          });
        }
      } catch (error) {
        this.$apiErrorHandler(error);
      }
    }
  },
  async crawledDailyNewsAction() {
    const hasDate = !!this.date;
    if (hasDate) {
      const date = this.date.toLocaleDateString();
      const requestData = {
        startAt: (new Date(`${date} 00:00:00`)).getTime() / 1000,
        endAt: (new Date(`${date} 23:59:59`)).getTime() / 1000,
        page: Number(this.crawlingPage),
      };

      try {
        const { data } = await this.$api(api.CrawledNewsRequest, requestData);
        if (!data.finished) {
          this.crawlingPage = data['nextPage'];
          this.crawlingResultMessage = `${ this.crawlingPage - 1 }/${data['totalPage']} success`;
        } else {
          this.crawlingResultMessage = `${date} finished`;
        }
      } catch (error) {
        this.$apiErrorHandler(error);
      }
    }
  },
  updateSelectedNewsAction({ selection, row }) {
    this.selectedData = selection;
  },
  async classifyAction() {
    const requestData = {
      newsIdList: []
    };

    this.selectedData.forEach(news => {
      requestData.newsIdList.push({ id: news.id });
    });

    try {
      const { status, code } = await this.$api(api.ClassifyNewsRequest, requestData);
      const classifySuccess = status && code === 200;
      if (classifySuccess) {
        await this.getDailyNewsAction(this.currentSearchFilter);
      }
      this.selectedData = [];
    } catch (error) {
      this.$apiErrorHandler(error);
    }
  },
  async classifyByTimeAction() {
    if (this.classifyDates && this.classifyDates.length === 2) {
      const startAt = this.classifyDates[0].toLocaleDateString();
      const endAt = this.classifyDates[1].toLocaleDateString();
      const requestData = {
        startAt: (new Date(`${startAt} 00:00:00`)).getTime(),
        endAt: (new Date(`${endAt} 00:00:00`)).getTime(),
      };

      try {
        await this.$api(api.ClassifyNewsByTimestampRequest, requestData);
      } catch (error) {
        this.$apiErrorHandler(error);
      }
    }
  }
};

export default {
  name: "news",
  components: {StockListPage},
  data() {
    return {
      date: (new Date()).toLocaleDateString(),
      lastDate: undefined,
      searchColumns: [
        {value: 'id', label: 'ID'},
        {value: 'title', label: 'Title'},
      ],
      tableColumns: [
        columns.selection,
        columns.index,
        columns.id,
        {
          title: 'Title',
          render: (h, params) => {
            const title = params.row['title'];
            const url = params.row['url'];
            return h('a', { attrs: { href: url, target: "_blank" } }, title);
          },
        },
        {
          title: 'is-classified',
          width: 150,
          align: 'center',
          fixed: 'right',
          render: (h, params) => {
            if (params.row['classify'] === 1) {
              return h('Icon', { props: { type: 'md-checkmark-circle-outline', color: '#00d9af', size: 20 } }, '');
            } else {
              return h('Icon', { props: { type: 'md-close-circle', color: '#ff6666', size: 20 } }, '');
            }
          }
        }
      ],
      tableData: undefined,
      totalData: 0,
      crawlingPage: 1,
      crawlingResultMessage: undefined,
      currentSearchFilter: {},
      selectedData: [],
      pageAt: 1,
      classifyDates: undefined,
    };
  },
  watch: {
    date(val, oldVal) {
      if (oldVal && oldVal instanceof Date) {
        this.lastDate = oldVal.toLocaleDateString();
      }
    }
  },
  methods: {
    ...actions,
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
}
</script>

<style lang="scss" scoped>
  @import "../../../assets/css/mixin";
  .manager-stock-data-news {
    .tool-item {
      padding: 5px 10px;
      border-radius: 4px;
    }
    .search-btn {
      margin-left: 10px;
      @include circle-div-btn(32);
    }
    .page-message {
      height: 100%;
      padding: 0 5px;
      border-radius: 4px;
      font-size: 16px;
    }
    .crawling-message {
      position: absolute;
      top: -30px;
      font-size: 16px;
    }
    .classify-by-time-btn {
      margin-left: 10px;
      @include circle-div-btn(32);
    }
    .crawled-btn {
      margin-left: 10px;
      @include circle-div-btn(32);
    }
  }
</style>
